<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 417 $
 * $Id: EditPunch.php 417 2006-12-06 22:58:53Z ipso $
 * $Date: 2006-12-06 14:58:53 -0800 (Wed, 06 Dec 2006) $
 */
require_once('../../includes/global.inc.php');

//Debug::setVerbosity(11);

$skip_message_check = TRUE;
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

if ( !$permission->Check('punch','enabled')
		OR !( $permission->Check('punch','edit')
				OR $permission->Check('punch','edit_own')
				OR $permission->Check('punch','edit_child')
				 ) ) {
	$permission->Redirect( FALSE ); //Redirect
}

$title = 'Mass Punch';
$smarty->assign('title', $title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'id',
												'pc_data',
												'filter_user_id'												
												) ) );

$punch_full_time_stamp = NULL;
if ( isset($pc_data) ) {
	if ( $pc_data['start_date_stamp'] != ''
			AND !is_numeric($pc_data['start_date_stamp'])
			AND $pc_data['end_date_stamp'] != ''
			AND !is_numeric($pc_data['end_date_stamp'])
			AND $pc_data['time_stamp'] != ''
			AND !is_numeric($pc_data['time_stamp'])
			) {
		$pc_data['start_punch_full_time_stamp'] = TTDate::parseDateTime($pc_data['start_date_stamp'].' '.$pc_data['time_stamp']);
		$pc_data['end_punch_full_time_stamp'] = TTDate::parseDateTime($pc_data['end_date_stamp'].' '.$pc_data['time_stamp']);
		$pc_data['time_stamp'] = TTDate::parseDateTime($pc_data['start_date_stamp'].' '.$pc_data['time_stamp']);
	} else {
		$pc_data['start_punch_full_time_stamp'] = NULL;
		$pc_data['end_punch_full_time_stamp'] = NULL;
	}

	if ( $pc_data['start_date_stamp'] != '') {
		$pc_data['start_date_stamp'] = TTDate::parseDateTime($pc_data['start_date_stamp']);
	}
	if ( $pc_data['end_date_stamp'] != '') {
		$pc_data['end_date_stamp'] = TTDate::parseDateTime($pc_data['end_date_stamp']);
	}
	
}

//Get Permission Hierarchy Children first, as this can be used for viewing, or editing.
$hlf = new HierarchyListFactory();
$permission_children_ids = $hlf->getHierarchyChildrenByCompanyIdAndUserIdAndObjectTypeID( $current_company->getId(), $current_user->getId() );
Debug::Arr($permission_children_ids,'Permission Children Ids:', __FILE__, __LINE__, __METHOD__,10);
$filter_data = NULL;
if ( $permission->Check('schedule','view_child') ) {
	$filter_data['permission_children_ids'] = $permission_children_ids;
}
if ( $permission->Check('schedule','view') == FALSE AND $permission->Check('schedule','view_own') == TRUE ) {
	$filter_data['permission_children_ids'][] = $current_user->getId();
}

$pcf = new PunchControlFactory();
$pf = new PunchFactory();
$ulf = new UserListFactory();

$action = strtolower($action);
switch ($action) {
	case 'submit':
		//Debug::setVerbosity(11);
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);

		$fail_transaction = FALSE;

		if ( TTDate::getDayDifference( $pc_data['start_date_stamp'], $pc_data['end_date_stamp']) > 31 ) {
			Debug::Text('Date Range Exceeds 31 days, truncating', __FILE__, __LINE__, __METHOD__,10);
			$pc_data['end_date_stamp'] = $pc_data['start_date_stamp'] + (86400*31);
		}

		if ( isset($filter_user_id) AND is_array($filter_user_id) AND count($filter_user_id) > 0 ) {
			$pf->StartTransaction();
			
			$time_stamp = $pc_data['start_punch_full_time_stamp'];
			while ( $time_stamp <= $pc_data['end_punch_full_time_stamp'] ) {				
				if ( isset($pc_data['dow'][TTDate::getDayOfWeek( $time_stamp )]) AND $pc_data['dow'][TTDate::getDayOfWeek( $time_stamp )] == 1 ) {				
					foreach( $filter_user_id as $user_id ) {
						$ulf->getByIdAndCompanyId($user_id,  $current_company->getId() );
						if ( $ulf->getRecordCount() == 1 ) {
							$user_obj = $ulf->getCurrent();
							$user_generic_status_label = $user_obj->getFullName(TRUE) .' @ '. TTDate::getDate('DATE+TIME', $time_stamp);
						} else {
							$user_obj = NULL;
							$user_generic_status_label = 'N/A @ '. TTDate::getDate('DATE+TIME', $time_stamp);
						}
						
						
						$pcf = new PunchControlFactory();
						$pf = new PunchFactory();
			
						Debug::Text('Punch Full Time Stamp: '. TTDate::getDate('DATE+TIME', $time_stamp), __FILE__, __LINE__, __METHOD__,10);
			
						$pcf->findUserDate( $user_id, $time_stamp, $pc_data['status_id'] );
			
						//Try to find a punch_control_id we can attach to safely.
						$pclf = new PunchControlListFactory();
						$tmp_punch_control_id = $pclf->getInCompletePunchControlIdByUserDateIdAndEpoch( $pcf->getUserDateId(), $time_stamp, $pc_data['status_id'] );
						if ( $tmp_punch_control_id !== FALSE ) {
							$pcf->setId( $tmp_punch_control_id );
						}
						
						if ( isset($pc_data['branch_id']) AND $pc_data['branch_id'] == -1 ) {
							$pcf->setBranch( $user_obj->getDefaultBranch() );
						} elseif ( isset($pc_data['branch_id']) ) {
							$pcf->setBranch( $pc_data['branch_id'] );
						}
						if ( isset($pc_data['department_id']) AND $pc_data['department_id'] == -1 ) {
							$pcf->setDepartment( $user_obj->getDefaultDepartment() );
						} elseif ( isset($pc_data['department_id']) ) {
							$pcf->setDepartment( $pc_data['department_id'] );
						}
						
						if ( isset($pc_data['job_id']) ) {
							$pcf->setJob( $pc_data['job_id'] );
						}
						if ( isset($pc_data['job_item_id']) ) {
							$pcf->setJobItem( $pc_data['job_item_id'] );
						}
						if ( isset($pc_data['quantity']) ) {
							$pcf->setQuantity( $pc_data['quantity'] );
						}
						if ( isset($pc_data['bad_quantity']) ) {
							$pcf->setBadQuantity( $pc_data['bad_quantity'] );
						}
						if ( isset($pc_data['note']) ) {
							$pcf->setNote( $pc_data['note'] );
						}
			
						if ( isset($pc_data['other_id1']) ) {
							$pcf->setOtherID1( $pc_data['other_id1'] );
						}
						if ( isset($pc_data['other_id2']) ) {
							$pcf->setOtherID2( $pc_data['other_id2'] );
						}
						if ( isset($pc_data['other_id3']) ) {
							$pcf->setOtherID3( $pc_data['other_id3'] );
						}
						if ( isset($pc_data['other_id4']) ) {
							$pcf->setOtherID4( $pc_data['other_id4'] );
						}
						if ( isset($pc_data['other_id5']) ) {
							$pcf->setOtherID5( $pc_data['other_id5'] );
						}
			
			
						if ( $pcf->isValid() == TRUE ) {
							$punch_control_id = $pcf->Save();
			
							//If its an update, not a new insert
							if ( $punch_control_id === TRUE ) {
								$punch_control_id = $tmp_punch_control_id;
							}
							Debug::Text(' Punch Control ID: '. $punch_control_id, __FILE__, __LINE__, __METHOD__,10);
			
							if ( isset($data['transfer']) ) {
								$pf->setTransfer( TRUE );
							}
							$pf->setPunchControlID( $punch_control_id );
							$pf->setType( $pc_data['type_id'] );
							$pf->setStatus( $pc_data['status_id'] );
							if ( isset($pc_data['disable_rounding']) ) {
								$enable_rounding = FALSE;
							} else {
								$enable_rounding = TRUE;
							}
							$pf->setTimeStamp( $time_stamp, $enable_rounding );
			
							if ( $pf->isNew() ) {
								$pf->setActualTimeStamp( $time_stamp );
								$pf->setOriginalTimeStamp( $pf->getTimeStamp() );
							}
			
							if ( $pf->isValid() ) {
								$pf->setEnableCalcTotalTime( TRUE );
								$pf->setEnableCalcSystemTotalTime( TRUE );
								$pf->setEnableCalcWeeklySystemTotalTime( TRUE );
								$pf->setEnableCalcUserDateTotal( TRUE );
								$pf->setEnableCalcException( TRUE );
			
								if ( $pf->Save() != TRUE ) {
									Debug::Text(' aFail Transaction: ', __FILE__, __LINE__, __METHOD__,10);
									$fail_transaction = TRUE;
									break;
								} else {
									UserGenericStatusFactory::queueGenericStatus( $user_generic_status_label, 30, NULL, NULL );
								}
							} else {
								Debug::Text(' bFail Transaction: ', __FILE__, __LINE__, __METHOD__,10);
								
								UserGenericStatusFactory::queueGenericStatus( $user_generic_status_label, 10, $pf->Validator->getTextErrors(), NULL );
								
								$fail_transaction = TRUE;
								break;
							}
						} else {
							Debug::Text(' cFail Transaction: ', __FILE__, __LINE__, __METHOD__,10);
							
							UserGenericStatusFactory::queueGenericStatus( $user_generic_status_label, 10, $pcf->Validator->getTextErrors(), NULL );
							
							$fail_transaction = TRUE;
							break;
						}
						
					}
				} else {
					Debug::Text(' Skipping Day Of Week: ('. TTDate::getDayOfWeek( $time_stamp) .') '. TTDate::getDate('DATE+TIME', $time_stamp), __FILE__, __LINE__, __METHOD__,10);
				}
				$time_stamp = $time_stamp + 86400;
			}
			
			//$pf->FailTransaction();
			$pf->CommitTransaction();
			
			$ugsf = new UserGenericStatusFactory();
			$ugsf->setUser( $current_user->getId() );
			$ugsf->setBatchID( $ugsf->getNextBatchId() );
			$ugsf->setQueue( UserGenericStatusFactory::getStaticQueue() );
			$ugsf->saveQueue();
			Redirect::Page( URLBuilder::getURL( array('batch_id' => $ugsf->getBatchID(), 'batch_title' => 'Mass Punch', 'batch_next_page' => urlencode( URLBuilder::getURL( array('pc_data' => $pc_data, 'filter_user_id' => $filter_user_id ), '../punch/AddMassPunch.php' ) ) ), '../users/UserGenericStatusList.php') );
		} else {
			$pcf->Validator->isTrue('user_id',FALSE, 'Please select at least one employee');
		}
	default:
		if ( $action != 'submit' AND !is_array($pc_data) ) {
			Debug::Text(' ID was NOT passed: '. $id, __FILE__, __LINE__, __METHOD__,10);
			$time_stamp = $date_stamp = TTDate::getBeginDayEpoch( TTDate::getTime() ) + (3600*12); //Noon
			
			$pc_data = array(
							//'user_id' => $user_obj->getId(),
							//'user_full_name' => $user_obj->getFullName(),
							'start_date_stamp' => $date_stamp,
							'end_date_stamp' => $date_stamp,
							'time_stamp' => $time_stamp,
							'status_id' => 10,
							//'branch_id' => $user_obj->getDefaultBranch(),
							//'department_id' => $user_obj->getDefaultDepartment(),
							'quantity' => 0,
							'bad_quantity' => 0,
							'dow' => array(1 => TRUE, 2 => TRUE, 3 => TRUE, 4 => TRUE, 5 => TRUE)
							);


			unset($time_stamp, $date_stamp);
		}
		//var_dump($pc_data);

		$ulf = new UserListFactory();
		$ulf->getSearchByCompanyIdAndArrayCriteria( $current_company->getId(), $filter_data );
		$user_options = UserListFactory::getArrayByListFactory( $ulf, FALSE, FALSE );

		if ( $filter_user_id != '' AND is_array($filter_user_id) ) {
			$tmp_user_options = UserListFactory::getByCompanyIdArray( $current_company->getId(), FALSE, TRUE );
			foreach( $filter_user_id as $user_id ) {
				$filter_user_options[$user_id] = $tmp_user_options[$user_id];
			}
		}

		$prepend_array_option = array( 0 => '--', -1 => '-- Default --' );

		$blf = new BranchListFactory();
		$blf->getByCompanyId( $current_company->getId() );
		$branch_options = Misc::prependArray( $prepend_array_option,  $blf->getArrayByListFactory( $blf, FALSE, TRUE ) );

		$dlf = new DepartmentListFactory();
		$dlf->getByCompanyId( $current_company->getId() );
		$department_options = Misc::prependArray( $prepend_array_option,  $dlf->getArrayByListFactory( $dlf, FALSE, TRUE ) );

		if ( $current_company->getProductEdition() == 20 ) {
			$jlf = new JobListFactory();
			$jlf->getByStatusIdAndCompanyId( array(10,20,30,40), $current_company->getId() );
			//$jlf->getByCompanyIdAndUserIdAndStatus( $current_company->getId(),  $pc_data['user_id'], array(10,20,30,40) );
			$pc_data['job_options'] = $jlf->getArrayByListFactory( $jlf, TRUE, TRUE );
			$pc_data['job_manual_id_options'] = $jlf->getManualIDArrayByListFactory($jlf, TRUE);

			$jilf = new JobItemListFactory();
			$jilf->getByCompanyId( $current_company->getId() );
			$pc_data['job_item_options'] = $jilf->getArrayByListFactory( $jilf, TRUE );
			$pc_data['job_item_manual_id_options'] = $jilf->getManualIdArrayByListFactory( $jilf, TRUE );
		}

		//Select box options;
		$smarty->assign_by_ref('user_options', $user_options);		
		$smarty->assign_by_ref('filter_user_options', $filter_user_options);
		
		$pc_data['status_options'] = $pf->getOptions('status');
		$pc_data['type_options'] = $pf->getOptions('type');
		$pc_data['branch_options'] = $branch_options;
		$pc_data['department_options'] = $department_options;

		//Get other field names
		$oflf = new OtherFieldListFactory();
		$pc_data['other_field_names'] = $oflf->getByCompanyIdAndTypeIdArray( $current_company->getId(), 15 );

		//var_dump($pc_data);
		$smarty->assign_by_ref('pc_data', $pc_data);

		break;
}

$smarty->assign_by_ref('pcf', $pcf);
$smarty->assign_by_ref('pf', $pf);

$smarty->display('punch/AddMassPunch.tpl');
?>